/* -------------------------------------------------------------- */
/* GraTex v.1.1      15.11.1989            (C) Attic,1989         */
/*                                                                */
/*         Header File - GT.H                                     */
/* -------------------------------------------------------------- */
/*                                               */
/*                  ------------------                            */
#define GT_VMode       gmode              /*            */
#define GT_ScreenX     scrxs              /*          */
#define GT_ScreenY     scrys              /*          */
#define G4Mode         ((int)0)           /*  256*256  16   */
#define G5Mode         ((int)1)           /*  512*256  4     */
#define G6Mode         ((int)2)           /*  512*256  16   */
#define G7Mode         ((int)3)           /*  256*256 256   */
/*                                                                */
/*           VMode                            */
#define GT_SetVMode(GMode)    gbpi ((int)(GMode))
/*                       */
#define GT_Term               gbpt
/*                                                                */
/*                                                                */
/*                                       */
/*               ---------------------------                      */
/*                                                        */
/*         --------                                               */
/*                Page  */
#define GT_SetWorkingPage(Page)  inps((int)(Page))
/*                Page  */
#define GT_SetVisualPage(Page)   outps((int)(Page))
/*                                                                */
/*                                                  */
/*         ----------------                                       */
#define GT_Color      palfc      /*                    */
/*                                                                */
/*           Color  N                       */
#define GT_SetPaletteColor(N,Color) pals((int)(N),(int)(Color))

/*          4,5,6                              */
#define Black    (int)(0x0000)
#define Green    (int)(0x0006)
#define L_Green  (int)(0x0007)
#define Blue     (int)(0x0700)
#define L_Blue   (int)(0x0703)
#define D_Red    (int)(0x5000)
#define Cyan     (int)(0x0707)
#define Red      (int)(0x7000)
#define L_Red    (int)(0x7303)
#define Yellow   (int)(0x7007)
#define White    (int)(0x7707)
#define D_Green  (int)(0x0004)
#define Magenta  (int)(0x6502)
#define Grey     (int)(0x5505)
#define Backgr   (int)(0x0300)

/*                                                                */
/*                                */
/*         ------------------------------------                   */
#define GT_LWrite glogop      /*                      */
#define LId     ((int)0x00)   /*             D = S                */
#define LAnd    ((int)0x01)   /*             D = S & D            */
#define LOr     ((int)0x02)   /*             D = S | D            */
#define LXor    ((int)0x03)   /*             D = S ^ D            */
#define LNot    ((int)0x04)   /*             D =   ~ S            */
#define LNZId   ((int)0x08)   /*             D = (S ?  S     : 0) */
#define LNZAnd  ((int)0x09)   /*             D = (S ? (S & D): 0) */
#define LNZOr   ((int)0x0A)   /*             D = (S ? (S | D): 0) */
#define LNZXor  ((int)0x0B)   /*             D = (S ? (S ^ D): 0) */
#define LNZNot  ((int)0x0C)   /*             D = (S ? (  ~ S): 0) */

/*                                                  */
/*         ---------------                                        */
#define GT_CPX   cpx        /*       , X- */
#define GT_CPY   cpy        /*       , Y- */
/*              (X,Y)                 */
#define GT_AbsMove(X,Y)     absmov((int)(X),(int)(Y))
/*              (X,Y)               */
#define GT_RelMove(X,Y)     relmov((int)(X),(int)(Y))
/*                                                                */
/*                                                                */
/*                                              */
/*               -------------------                              */
/*                                                           */
/*         -----                                                  */
/*                                       */
#define GT_Dot               dot
/*            ( X,Y )                                  */
#define GT_AbsDot(X,Y)       absdot((int)(X),(int)(Y))
/*            ( GT_CPX+X, GT_CPY+Y )                   */
#define GT_RelDot(X,Y)       reldot((int)(X),(int)(Y))
/*                                                                */
/*                                                         */
/*         -------                                                */
/*               (X,Y)               */
#define GT_AbsLine(X,Y)      abslin((int)(X),(int)(Y))
/*               (GT_CPX+X,GT_CPY+Y) */
#define GT_RelLine(X,Y)      rellin((int)(X),(int)(Y))
/*                                                                */
/*                                                */
/*         ------------------                                     */
/*            Radius                   */
#define GT_Circle(Radius)    circle((int)(Radius))
/*            Radius                         */
#define GT_FCircle(Radius)   fcircle((int)(Radius))
/*                                                                */
/*                                                         */
/*         -------                                                */
/*               B                    */
#define GT_Ellipse(A,B)      ellipse((int)(A),(int)(B))
/*                B        */
#define GT_FEllipse(A,B)     fellipse((int)(A),(int)(B))
/*                                                                */
/*                                                                */
/*                                               */
/*             ------------------                                 */
/*                                            */
/*         -----------------------                                */
/*           (X,Y)   Code               */
#define GT_PutPixel(X,Y,Code) pset((int)(X),(int)(Y),(int)(Code))
/*            (X,Y)                        */
#define chGT_GetPixel(X,Y)    pget((int)(X),(int)(Y))
/*                                                                */
/*                                       */
/*         ---------------------------                            */
/*                                           */
#define GT_Recol          fill
/*                                               */
#define GT_Fill(Code)     bfill((int)(Code))
/*                                                                */
/*         a                                         */
/*         ----------------                                       */
/*             SideX,SideY              */
#define GT_Frame(SideX,SideY)   rect((int)(SideX),(int)(SideY))
/*             SideX,SideY      */
#define GT_Rect(SideX,SideY)   block((int)(SideX),(int)(SideY))
/*             Page                      */
#define GT_BlockCopy(SideX,SideY,X,Y,Page) \
  blccop((int)(SideX),(int)(SideY),(int)(X),(int)(((Y)+(Page)*256)))
/*            ,   pchAddress           */
#define GT_BlockRead(SideX,SideY,pchAddress)  \
  vdump((int)(SideX),(int)(SideY),(char*)(pchAddress))
/*            ,   pchAddress          */
#define GT_BlockWrite(SideX,SideY,pchAddress) \
  mdump((int)(SideX),(int)(SideY),(char*)(pchAddress))
/*                                                                */
/*                                                                */
/*                                                  */
/*             ----------------                                   */
#define GT_BColor  palbc       /*     */
/*                                                                */
/*                N     */
#define GT_LoadDefaultFont(N)  loddflt((int)(N))
/*             File     N  */
#define GT_LoadFont(N,File)    lodfnt((int)(N),(char*)(File))
/*          N-                            */
#define GT_SetFont(N)          cfnts((int)(N))
/*                                                                */
#define GT_ChShiftX    cshftx  /*     */
#define GT_ChShiftY    cshfty  /*       */
/*                                                                */
/*           Char                                    */
#define GT_Char( Char )        goutch((char)(Char))
/*           String                                  */
#define GT_String( String )    goutst((char*)(String))
/*                                                                */
/*                                                                */
/*                                     */
/*             ------------------------------                     */
/*                                                   */
/*         ---------------                                        */
#define GT_MdX    mdispx /*       */
#define GT_MdY    mdispy /*      Y */
#define LeftBut   ((char)1)  /*                   */
#define RightBut  ((char)3)  /*                  */
/*                                                                */
/*            Button  ?                      */
#define chGT_MouseBut(Button)    mouseb((char)(Button))
/*                                         */
#define GT_MouseDisp             mouser
/*                                                                */
/*                                              */
/*         --------------------                                   */
/*                                        */
#define chGT_GetKey     getkey
/*           - ?                        */
#define chGT_Key        keyon
/*                                                                */
/*                                         */
/*         --------------------------                             */
/*           File                             */
#define chGT_FOpenR(File) gropen((char*)(File))
/*           File                             */
#define chGT_FOpenW(File) gwopen((char*)(File))
/*                                             */
#define chGT_FClose       gclose
/*                                                                */
/*             Length ,     */
/*            Start     Address        */
#define chGT_Read( Length,Address,Start) \
         gread((int)(Length),(char*)(Address),(int)(Start))
/*               Length        */
/*           Address                                       */
#define chGT_Write(Length,Address,Start)  \
         gwrite((int)(Length),(char*)(Address),(int)(Start))
/* -------------------------------------------------------------- */

extern  int    gmode;
extern  int    palbc;
extern  int    palfc;
extern  int    cpx;
extern  int    cpy;
extern  int    scrxs;
extern  int    scrys;
extern  int    glogop;
extern  int    pagin;
extern  int    pagou;
extern  int    cshftx;
extern  int    cshfty;
extern  int    mdispx;
extern  int    mdispy;

extern         gbpi();
extern         gbpt();

extern         inps();
extern         outps();
extern         pals();
extern         absmov();
extern         relmov();

extern         dot();
extern         absdot();
extern         reldot();
extern         abslin();
extern         rellin();
extern         circle();
extern         fcircle();
extern         ellipse();
extern         fellipse();

extern  char   pget();
extern         pset();
extern         fill();
extern         bfill();

extern         rect();
extern         block();
extern         blccop();
extern         mdump();
extern         vdump();

extern  char   mouseb();
extern         mouser();
extern  char   getkey();
extern  char   keyon();

extern         lodfnt();
extern         loddflt();
extern         cfnts() ;
extern         goutch();
extern         goutst();

extern  char   gropen();
extern  char   gwopen();
extern  char   gclose();
extern  char   gread();
extern  char   gwrite();
